// Copyright 2019 Workiva Inc.
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

library strictmode_component_test;

import 'dart:html';

import 'package:over_react/over_react.dart';
import 'package:over_react_test/over_react_test.dart';
import 'package:test/test.dart';

void main() {
  group('StrictMode', () {
    test('renders only its children', () {
      DivElement wrappingDivRef;

      renderAttachedToDocument(
        (Dom.div()
          ..ref = (ref) {
            wrappingDivRef = ref;
          })(StrictMode()(
          Dom.div()(),
          Dom.div()(),
          Dom.div()(),
          Dom.div()(),
        )),
      );

      expect(wrappingDivRef.children, hasLength(4));
    });
  });
}
